unit ColorEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TColorEdit = class(TEdit)
  private
    FCurrentColor: TColor;
    FCurrentFont: TColor;
    FNormalCOlor: TColor;
    FNormalFont: TFont;
    procedure SetCurrentColor(const Value: TColor);
    procedure SetCurrentFont(const Value: TColor);
    procedure Enter(Sender: TObject);
    procedure Exit(Sender: TObject);
    { Private declarations }
  protected
    { Protected declarations }
  public
   constructor Create(AOwner: TComponent);override;
   destructor Destroy; override;
  published
   property CurrentColor: TColor read FCurrentColor write SetCurrentColor;
   property CurrentFont: TColor read FCurrentFont write SetCurrentFont;
   property OnEnter;
   property OnExit;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('dg', [TColorEdit]);
end;

{ TColorEdit }

constructor TColorEdit.Create(AOwner: TComponent);
begin
  inherited;
  Self.OnEnter:=Enter;
  Self.OnExit:=Exit;
  CurrentColor:=clBlue;
  FNormalFont:=TFont.Create;
  FCurrentFont:=clWhite;
end;

destructor TColorEdit.Destroy;
begin
 FNormalFont.Destroy;
 inherited;
end;

procedure TColorEdit.Enter(Sender: TObject);
begin
 FNormalColor:=COlor;
 FNormalFont.Assign(Self.Font);
 Color:=FCurrentColor;
 Font.Color:=FCurrentFont;
end;

procedure TColorEdit.Exit(Sender: TObject);
begin
 Color:=FNormalColor;
 Font.Assign(FNormalFont);
end;

procedure TColorEdit.SetCurrentColor(const Value: TColor);
begin
  FCurrentColor := Value;
end;

procedure TColorEdit.SetCurrentFont(const Value: TColor);
begin
  FCurrentFont:=Value;
end;

end.
